
var explosionType : GameObject;

public var enemy_tag : String;

private var throttle = 0.0;
private var cursor = Vector3(0.5,0.5,0.0);
private var aim_ray = Ray(Vector3.zero, Vector3.forward);
private var aim_position = Vector3.zero;

private var shieldsUp = false;
private var shield_cooldown = 0.0;


// The current move direction in x-z
private var moveDirection = Vector3.zero;
private var forward = Vector3.zero;
private var right = Vector3.zero;

static private var cameraObject : Camera;
private var shield_mesh : Transform;

private var hp_indicator : TextMesh;
private var influence : Influence;

private var ship : ShipModel;
private var boid : Steerable;

private var target : Transform;
	
function Awake ()
{
	ship = GetComponent(ShipModel);
	
	hp_indicator = transform.Find("hitpoints").GetComponent(TextMesh);
	hp_indicator.text = "" + ship.hitPoints;
	
	influence = transform.GetComponentInChildren(Influence);

	moveDirection = transform.TransformDirection(Vector3.forward);
    forward = transform.TransformDirection(Vector3.forward);
	right = Vector3(forward.z, 0, -forward.x);
}

function OnDamage(amount : float) {
	hp_indicator.text = "" + ship.hitPoints;
}

function FixedUpdate() {
    //Thrust(throttle);
	//boid.Thrust(1.0);
	think();

    //transform.position = rigidbody.position;
    //transform.localRotation = rigidbody.rotation;
}



function think() {
	if(influence.GetBlocker() != null) target = influence.GetBlocker().transform;
	else return;
	
    var relative_pos = (target.position - transform.position);
    forward = transform.TransformDirection(Vector3.forward);

    var aim_point = target.transform.position;
	aim_point.z = 0;
	
    ship.SetAimPos(aim_point);
	
    var dist2targ = relative_pos.sqrMagnitude;
	var weaponRange = 49; // weapon range squared
	
	// aim point-defense turrets at closest enemy drone
	
	// aim capship turrets
	var turrets = transform.GetComponentsInChildren(Steerable_bodiless); 
	for(var turret : Steerable_bodiless in turrets) {
		turret.SetAimPos(target.position);
		turret.turnTo2D(target.position);
		if( dist2targ < weaponRange ) turret.BroadcastMessage("Pewpew", aim_point);
	}
		
	
}

function OnTriggerEnter(collider : Collider) {
	if(collider.gameObject.CompareTag("Finish")) {
		Debug.Log(ship.team + " win!");
	}
}

function Update() {
    forward = transform.TransformDirection(Vector3.forward);
}

@script RequireComponent(ShipModel)
@script AddComponentMenu("Oolong/Capital Ship (Model)")
