@script ExecuteInEditMode()

// radar! by PsychicParrot, adapted from a Blitz3d script found in the public domain online somewhere ..
//

public var friendlyBlip : Texture;
public var enemyBlip : Texture;
public var blipSize : int = 4;
public var radarBG : Texture;

public var centerObject : Transform;
public var centerCamera : Camera;
public var mapScale = 0.3;
private var mapCenter : Vector2;

public var size : int = 128;
private var sizehalf : int = size / 2;

function Start () {
    mapCenter = new Vector2(transform.position.x * Screen.width, Screen.height - (transform.position.y * Screen.height));

}

function OnGUI () {
    
    //  GUI.matrix = Matrix4x4.TRS (Vector3.zero, Quaternion.identity, Vector3(Screen.width / 600.0, Screen.height / 450.0, 1));

    // Draw player blip (centerObject)
    bX=centerObject.transform.position.x * mapScale;
    bY=centerObject.transform.position.z * mapScale;
        
    bX=centerObject.transform.position.x * mapScale;
    bY=centerObject.transform.position.z * mapScale;
        
    GUI.DrawTexture(Rect(mapCenter.x-sizehalf,mapCenter.y-sizehalf,size,size),radarBG);
    
    // Draw blips for zombies
    DrawBlipsForEnemies();
    
}

function DrawBlipsForCows(){
    
     // Find all game objects with tag Cow
    var gos : GameObject[];
    gos = GameObject.FindGameObjectsWithTag("Cow"); 

    var distance = Mathf.Infinity; 
    var position = transform.position; 

    // Iterate through them
    for (var go : GameObject in gos)  { 

        drawBlip(go,enemyBlip);

    }
 
}

function drawBlip(go,aTexture){
    var debug = GameObject.Find("Debug Text").GetComponent(GUIText);

    centerPos=centerObject.position;
    extPos=go.transform.position;
    
    // first we need to get the distance of the enemy from the player
    dist=Vector3.Distance(centerPos,extPos);

    //var screen_relation = centerCamera.WorldToScreenPoint(extPos);
    var relation = centerCamera.WorldToViewportPoint(extPos);
    bX = (relation.x - 0.5) * mapScale;
    bY = (relation.y - 0.5) * -mapScale;

    // FIXME : need to fix this so it's not a "square" relation, but a 
    // circular / spherical mapping
    if( relation.z < 0 ){
        bX = Mathf.Sign(bX) * -sizehalf;
        bY = Mathf.Sign(bY) * -sizehalf;
    }

    /*
    dx=centerPos.x-extPos.x; // how far to the side of the player is the enemy?
    dz=centerPos.z-extPos.z; // how far in front or behind the player is the enemy?
    
    // what's the angle to turn to face the enemy - compensating for the player's turning?
    deltay=Mathf.Atan2(dx,dz)*Mathf.Rad2Deg - 270 - centerObject.eulerAngles.y;
    
    // just basic trigonometry to find the point x,y (enemy's location) given the angle deltay
    bX=dist*Mathf.Cos(deltay * Mathf.Deg2Rad);
    bY=dist*Mathf.Sin(deltay * Mathf.Deg2Rad);

    bX=bX*mapScale; // scales down the x-coordinate by half so that the plot stays within our radar
    bY=bY*mapScale; // scales down the y-coordinate by half so that the plot stays within our radar
    */
    
    

    if (bX > sizehalf) { bX = sizehalf; }
    else if (bX < -sizehalf) { bX = -sizehalf; }
    if (bY > sizehalf) { bY = sizehalf; }
    else if (bY < -sizehalf) { bY = -sizehalf; }

    debug.text = "";
    debug.text += "viewport: " + relation.ToString();
    //debug.text += "\nscreen: " + screen_relation.ToString();
    debug.text += "\nbX " + bX;
    debug.text += "\nbY" + bY;

    if(dist<=200){ 
        // this is the diameter of our largest radar circle
       GUI.DrawTexture(Rect(mapCenter.x+bX,mapCenter.y+bY,blipSize, blipSize),aTexture);

    }

}

function DrawBlipsForEnemies(){
    
    // Find all game objects tagged Enemy
    var gos : GameObject[];
    gos = GameObject.FindGameObjectsWithTag("Enemy"); 

    var distance = Mathf.Infinity; 
    var position = transform.position; 

    // Iterate through them and call drawBlip function
    for (var go : GameObject in gos)  {
        if(go.transform == centerObject){ continue; } 
        var othership = go.GetComponent(ShipModel);
        var thisship = centerObject.GetComponent(ShipModel);
        if(othership.team == thisship.team) {
            drawBlip(go,friendlyBlip);
        }
        else {
            drawBlip(go,enemyBlip);
        }
    }
 
}

