using UnityEngine;

[AddComponentMenu("Oolong/Turret - Omnidirectional")]

public class Turret_omni : MonoBehaviour
{
    public float yaw = 25.0f;
    public float pitch = 25.0f;
    public float roll = 35.0f;

    private Vector3 cursor = new Vector3(0.5f,0.5f,0.0f);
    private Ray aim_ray = new Ray(Vector3.zero, Vector3.forward);
    private Vector3 aim_position = Vector3.zero;

    private Vector3 forward = Vector3.zero;


    public void Awake ()
    {
        forward = transform.TransformDirection(Vector3.forward);
    }



    public void FixedUpdate() {
        forward = transform.TransformDirection(Vector3.forward);
        //transform.position = rigidbody.position;
        //transform.localRotation = rigidbody.rotation;
    }

    public void SetCursor(Vector3 c) {
        c.x = Mathf.Clamp(c.x, -1.0f, 1.0f);
        c.y = Mathf.Clamp(c.y, -1.0f, 1.0f);

        cursor = c;
    }

    public Vector3 GetCursor() {
        return cursor;
    }

    public Vector3 GetAimPos() {
        return aim_position;
    }

    public void SetAimPos(Vector3 value) {
        aim_position = value;
		transform.LookAt(aim_position);
    }

}
